diff --git a/drivers/gpu/drm/i915/gem/i915_gem_shmem.c b/drivers/gpu/drm/i915/gem/i915_gem_shmem.c
index cc9fe258fba7..5a27b0225850 100644
--- a/drivers/gpu/drm/i915/gem/i915_gem_shmem.c
+++ b/drivers/gpu/drm/i915/gem/i915_gem_shmem.c
@@ -448,8 +448,7 @@ shmem_pwrite(struct drm_i915_gem_object *obj,
 			return err;
 
 		err = pagecache_write_begin(obj->base.filp, mapping,
-					    offset, len, 0,
-					    &page, &data);
+					    offset, len, &page, &data);
 		if (err < 0)
 			return err;
 
@@ -622,8 +621,7 @@ i915_gem_object_create_shmem_from_data(struct drm_i915_private *dev_priv,
 		void *pgdata, *vaddr;
 
 		err = pagecache_write_begin(file, file->f_mapping,
-					    offset, len, 0,
-					    &page, &pgdata);
+					    offset, len, &page, &pgdata);
 		if (err < 0)
 			goto fail;
 
diff --git a/fs/buffer.c b/fs/buffer.c
index c33e681fdeba..440979592c05 100644
--- a/fs/buffer.c
+++ b/fs/buffer.c
@@ -2352,7 +2352,7 @@ int generic_cont_expand_simple(struct inode *inode, loff_t size)
 	if (err)
 		goto out;
 
-	err = pagecache_write_begin(NULL, mapping, size, 0, 0, &page, &fsdata);
+	err = pagecache_write_begin(NULL, mapping, size, 0, &page, &fsdata);
 	if (err)
 		goto out;
 
@@ -2387,7 +2387,7 @@ static int cont_expand_zero(struct file *file, struct address_space *mapping,
 		}
 		len = PAGE_SIZE - zerofrom;
 
-		err = pagecache_write_begin(file, mapping, curpos, len, 0,
+		err = pagecache_write_begin(file, mapping, curpos, len,
 					    &page, &fsdata);
 		if (err)
 			goto out;
@@ -2420,7 +2420,7 @@ static int cont_expand_zero(struct file *file, struct address_space *mapping,
 		}
 		len = offset - zerofrom;
 
-		err = pagecache_write_begin(file, mapping, curpos, len, 0,
+		err = pagecache_write_begin(file, mapping, curpos, len,
 					    &page, &fsdata);
 		if (err)
 			goto out;
diff --git a/fs/ext4/verity.c b/fs/ext4/verity.c
index eacbd489e3bf..ed7bcf699348 100644
--- a/fs/ext4/verity.c
+++ b/fs/ext4/verity.c
@@ -79,7 +79,7 @@ static int pagecache_write(struct inode *inode, const void *buf, size_t count,
 		void *fsdata;
 		int res;
 
-		res = pagecache_write_begin(NULL, inode->i_mapping, pos, n, 0,
+		res = pagecache_write_begin(NULL, inode->i_mapping, pos, n,
 					    &page, &fsdata);
 		if (res)
 			return res;
diff --git a/fs/f2fs/verity.c b/fs/f2fs/verity.c
index fe5acdccaae1..e38fef7652ee 100644
--- a/fs/f2fs/verity.c
+++ b/fs/f2fs/verity.c
@@ -85,7 +85,7 @@ static int pagecache_write(struct inode *inode, const void *buf, size_t count,
 		void *addr;
 		int res;
 
-		res = pagecache_write_begin(NULL, inode->i_mapping, pos, n, 0,
+		res = pagecache_write_begin(NULL, inode->i_mapping, pos, n,
 					    &page, &fsdata);
 		if (res)
 			return res;
diff --git a/fs/hfs/extent.c b/fs/hfs/extent.c
index 263d5028d9d1..7ac7c74255be 100644
--- a/fs/hfs/extent.c
+++ b/fs/hfs/extent.c
@@ -491,7 +491,7 @@ void hfs_file_truncate(struct inode *inode)
 
 		/* XXX: Can use generic_cont_expand? */
 		size = inode->i_size - 1;
-		res = pagecache_write_begin(NULL, mapping, size+1, 0, 0,
+		res = pagecache_write_begin(NULL, mapping, size+1, 0,
 					    &page, &fsdata);
 		if (!res) {
 			res = pagecache_write_end(NULL, mapping, size+1, 0, 0,
diff --git a/fs/hfsplus/extents.c b/fs/hfsplus/extents.c
index 7054a542689f..6b37dbec9f0b 100644
--- a/fs/hfsplus/extents.c
+++ b/fs/hfsplus/extents.c
@@ -557,7 +557,7 @@ void hfsplus_file_truncate(struct inode *inode)
 		void *fsdata;
 		loff_t size = inode->i_size;
 
-		res = pagecache_write_begin(NULL, mapping, size, 0, 0,
+		res = pagecache_write_begin(NULL, mapping, size, 0,
 					    &page, &fsdata);
 		if (res)
 			return;
diff --git a/fs/namei.c b/fs/namei.c
index 4f5c07d5579f..48498737ee5c 100644
--- a/fs/namei.c
+++ b/fs/namei.c
@@ -5016,8 +5016,7 @@ int page_symlink(struct inode *inode, const char *symname, int len)
 retry:
 	if (nofs)
 		flags = memalloc_nofs_save();
-	err = pagecache_write_begin(NULL, mapping, 0, len-1,
-				0, &page, &fsdata);
+	err = pagecache_write_begin(NULL, mapping, 0, len - 1, &page, &fsdata);
 	if (nofs)
 		memalloc_nofs_restore(flags);
 	if (err)
diff --git a/fs/ntfs3/file.c b/fs/ntfs3/file.c
index 787b53b984ee..516efea57bfc 100644
--- a/fs/ntfs3/file.c
+++ b/fs/ntfs3/file.c
@@ -157,7 +157,7 @@ static int ntfs_extend_initialized_size(struct file *file,
 		if (pos + len > new_valid)
 			len = new_valid - pos;
 
-		err = pagecache_write_begin(file, mapping, pos, len, 0, &page,
+		err = pagecache_write_begin(file, mapping, pos, len, &page,
 					    &fsdata);
 		if (err)
 			goto out;
diff --git a/include/linux/pagemap.h b/include/linux/pagemap.h
index 76b0ddfef5ba..2e0a82a01564 100644
--- a/include/linux/pagemap.h
+++ b/include/linux/pagemap.h
@@ -535,9 +535,9 @@ static inline struct page *grab_cache_page_nowait(struct address_space *mapping,
  */
 static inline int pagecache_write_begin(struct file *file,
 		struct address_space *mapping, loff_t pos, unsigned len,
-		unsigned flags, struct page **pagep, void **fsdata)
+		struct page **pagep, void **fsdata)
 {
-	return mapping->a_ops->write_begin(file, mapping, pos, len, flags,
+	return mapping->a_ops->write_begin(file, mapping, pos, len, 0,
 						pagep, fsdata);
 }
 